'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var compiler = require('@nativescript-vue/compiler');
var runtime = require('@nativescript-vue/runtime');
var shared = require('@vue/shared');

function _interopNamespace(e) {
  if (e && e.__esModule) { return e; } else {
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        n[k] = e[k];
      });
    }
    n['default'] = e;
    return Object.freeze(n);
  }
}

var runtime__namespace = /*#__PURE__*/_interopNamespace(runtime);

//
const compileCache = Object.create(null);
function compileToFunction(template, options) {
    if (!shared.isString(template)) {
        return shared.NOOP;
    }
    const key = template;
    const cached = compileCache[key];
    if (cached) {
        return cached;
    }
    const { code } = compiler.compile(template, {
        // at runtime - the registry should know about all elements, so we override the
        // isNativeTag function from our standalone compiler
        isNativeTag: tag => runtime.isKnownView(tag),
        hoistStatic: true,
        onError(err) {
            // todo
        },
        ...options
    });
    // console.log(code)
    // const render = () => {}
    const render = new Function('Vue', code)(runtime__namespace);
    return (compileCache[key] = render);
}
runtime.registerRuntimeCompiler(compileToFunction);

Object.keys(runtime).forEach(function (k) {
  if (k !== 'default') exports[k] = runtime[k];
});
exports.compile = compileToFunction;
